import ReactExports from 'react';
import { shallow } from 'zustand/vanilla/shallow';

const { useRef } = ReactExports;
const sliceCache = /* @__PURE__ */ new WeakMap();
function useShallow(selector) {
  const key = useRef({}).current;
  return (state) => {
    const prev = sliceCache.get(key);
    const next = selector(state);
    if (shallow(prev, next)) {
      return prev;
    }
    sliceCache.set(key, next);
    return next;
  };
}

export { useShallow };
